CON
        _clkmode        = xtal1 + pll16x
        _xinfreq        = 5_000_000

CON
        Zeq0 = 0
        Zeq1 = 1
        Ceq0 = 0
        Ceq1 = 1

VAR

  long  Cog, TestVar

OBJ
  dbg   :       "PASDebug"                '<---- Add for Debugger 


PUB main

  Cog := cognew(@entry, @TestVar) + 1

  dbg.start(31,30,@entry)                 '<---- Add for Debugger

PUB stop

  if Cog
    cogstop(Cog~ -  1)

DAT

                       org     0
entry

'  --------- Debugger Kernel add this at Entry (Addr 0) ---------
   long $34FC1202,$6CE81201,$83C120B,$8BC0E0A,$E87C0E03,$8BC0E0A
   long $EC7C0E05,$A0BC1207,$5C7C0003,$5C7C0003,$7FFC,$7FF8
'  --------------------------------------------------------------

        '======= Subroutine TI (Test Instruction) executes SUBS with the
        '======= given values for dest, source, Z flag and C flag.
        '======= destExp is the expected result of the instruction and
        '======= Zexp and Cexp are the expected Z and C flags after execution
        '======= The routine returns a bit mapped result after execution...
        '=======   if dest   does not equal destExp, %100 is set.
        '=======   if Z flag does not equal Zexp,    %010 is set
        '=======   if C flag does not equal Cexp,    %001 is set

''      declareSub TI( dest, source, Zin, Cin, destExp, Zexp, Cexp)

''      array ans[10]

''      symbolicConstants Zeq0  Zeq1  Ceq0  Ceq1

''      ans[0] = beginAnsTag    ' Visually mark the beginning of the ans array
              mov       ans+0, beginAnsTag      

''      ans[1] = TI( con001, con001, Zeq0, Ceq0, con000, Zeq1, Ceq0)
              mov       TI_dest, con001         
              mov       TI_source, con001       
              mov       TI_Zin, #Zeq0           
              mov       TI_Cin, #Ceq0           
              mov       TI_destExp, con000      
              mov       TI_Zexp, #Zeq1          
              mov       TI_Cexp, #Ceq0          
              call      #TI                     
              mov       ans+1, TI_result        

''      ans[2] = TI( con001, con002, Zeq0, Ceq0, conFFF, Zeq0, Ceq0)
              mov       TI_dest, con001         
              mov       TI_source, con002       
              mov       TI_Zin, #Zeq0           
              mov       TI_Cin, #Ceq0           
              mov       TI_destExp, conFFF      
              mov       TI_Zexp, #Zeq0          
              mov       TI_Cexp, #Ceq0          
              call      #TI                     
              mov       ans+2, TI_result        

''      ans[3] = TI( conFFF, conFFF, Zeq0, Ceq0, con000, Zeq1, Ceq0)
              mov       TI_dest, conFFF         
              mov       TI_source, conFFF       
              mov       TI_Zin, #Zeq0           
              mov       TI_Cin, #Ceq0           
              mov       TI_destExp, con000      
              mov       TI_Zexp, #Zeq1          
              mov       TI_Cexp, #Ceq0          
              call      #TI                     
              mov       ans+3, TI_result        

''      ans[4] = TI( conFFF, conFFE, Zeq0, Ceq0, con001, Zeq0, Ceq0)
              mov       TI_dest, conFFF         
              mov       TI_source, conFFE       
              mov       TI_Zin, #Zeq0           
              mov       TI_Cin, #Ceq0           
              mov       TI_destExp, con001      
              mov       TI_Zexp, #Zeq0          
              mov       TI_Cexp, #Ceq0          
              call      #TI                     
              mov       ans+4, TI_result        

''      ans[5] = TI( con801, con001, Zeq0, Ceq0, con800, Zeq0, Ceq0)
              mov       TI_dest, con801         
              mov       TI_source, con001       
              mov       TI_Zin, #Zeq0           
              mov       TI_Cin, #Ceq0           
              mov       TI_destExp, con800      
              mov       TI_Zexp, #Zeq0          
              mov       TI_Cexp, #Ceq0          
              call      #TI                     
              mov       ans+5, TI_result        

''      ans[6] = TI( con801, con002, Zeq0, Ceq0, con7FF, Zeq0, Ceq1)
              mov       TI_dest, con801         
              mov       TI_source, con002       
              mov       TI_Zin, #Zeq0           
              mov       TI_Cin, #Ceq0           
              mov       TI_destExp, con7FF      
              mov       TI_Zexp, #Zeq0          
              mov       TI_Cexp, #Ceq1          
              call      #TI                     
              mov       ans+6, TI_result        

''      ans[7] = TI( con7FE, conFFF, Zeq0, Ceq0, con7FF, Zeq0, Ceq0)
              mov       TI_dest, con7FE         
              mov       TI_source, conFFF       
              mov       TI_Zin, #Zeq0           
              mov       TI_Cin, #Ceq0           
              mov       TI_destExp, con7FF      
              mov       TI_Zexp, #Zeq0          
              mov       TI_Cexp, #Ceq0          
              call      #TI                     
              mov       ans+7, TI_result        

''      ans[8] = TI( con7FE, conFFE, Zeq0, Ceq0, con800, Zeq0, Ceq1)
              mov       TI_dest, con7FE         
              mov       TI_source, conFFE       
              mov       TI_Zin, #Zeq0           
              mov       TI_Cin, #Ceq0           
              mov       TI_destExp, con800      
              mov       TI_Zexp, #Zeq0          
              mov       TI_Cexp, #Ceq1          
              call      #TI                     
              mov       ans+8, TI_result        

''      ans[9] = endAnsTag      ' Visually mark the end of the ans array
              mov       ans+9, endAnsTag        

''      loop
aac1                                            
''      endLoop
              jmp       #aac1                   
aac2                                            


'' beginsub TI {dest, source, Zin, Cin, destExp, Zexp, Cexp } 
TI                                              
''            
''            sub       TI_Zin,#1            wz,nr   ' Set Z flag = Zin
              sub       TI_Zin, #1              wz,nr
''            add       conFFF,TI_Cin        wc,nr   ' Set C flag = Cin
              add       conFFF, TI_Cin          wc,nr
''
''            {Execute the instruction under test and write Z and C flags}

''            subs      TI_dest, TI_source   wz,wc
              subs      TI_dest, TI_source      wz,wc
''            
''      if_z  sub  TI_Zexp,#1  
        if_z  sub       TI_Zexp, #1             
''      if_c  sub  TI_Cexp,#1
        if_c  sub       TI_Cexp, #1             
''
''            TI_result = 0
              mov       TI_result, #0           
''
''            if TI_Zexp <> 0           {Check for expected Z}
              cmp       TI_Zexp, #0             wc,wz
        if_e  jmp       #aac3                   
''              TI_result |= %010
              or        TI_result, #%010        
''            endif
aac3                                            
aac4                                            
''
''            if TI_Cexp <> 0           {Check for expected C}
              cmp       TI_Cexp, #0             wc,wz
        if_e  jmp       #aac5                   
''              TI_result |= %001
              or        TI_result, #%001        
''            endif
aac5                                            
aac6                                            
''
''            if TI_dest <> TI_destExp
              cmp       TI_dest, TI_destExp     wc,wz
        if_e  jmp       #aac7                   
''              TI_result |= %100
              or        TI_result, #%100        
''            endif
aac7                                            
aac8                                            
''             
'' endSub   TI
TI_ret        ret                               

beginAnsTag   long      $AAAAAAAA
endAnsTag     long      $BBBBBBBB

con000  long  $00000000
con001  long  $00000001
con002  long  $00000002
con7FF  long  $7FFFFFFF ' Largest positive number
con7FE  long  $7FFFFFFE ' Next largest positive number
con800  long  $80000000 ' Largest negative number
con801  long  $80000001 ' Next largest negative number
conFFF  long  $FFFFFFFF ' -1
conFFE  long  $FFFFFFFE ' -2

''  finishCodeSection   { !!!! important -- don't forget this }
'
' Subroutine parameters.....
'
TI_result                 res       1                       
TI_dest                   res       1                       
TI_source                 res       1                       
TI_Zin                    res       1                       
TI_Cin                    res       1                       
TI_destExp                res       1                       
TI_Zexp                   res       1                       
TI_Cexp                   res       1                       
ans                       res       10  {auto generated}    

                        fit     496
                          



